//
//  CostCentreTableViewController.m
//  iTimesheet
//
//  Created by Mark Brindle on 09/04/2011.
//  Copyright 2011 ARKEMM Software Limited. All rights reserved.
//

#import "CostCentreTableViewController.h"
#import "iTimesheetAppDelegate.h"
#import "PPCostCentre.h"
#import "InsertCostCentreViewController.h"

@implementation CostCentreTableViewController

// Manually synthesize the property we added
@synthesize costCentres;

#pragma mark - boilerplate code (provided by template)

- (id)initWithStyle:(UITableViewStyle)style
{
  self = [super initWithStyle:style];
  if (self) {
    // Custom initialization
  }
  return self;
}

- (void)didReceiveMemoryWarning
{
  // Releases the view if it doesn't have a superview.
  [super didReceiveMemoryWarning];
  
  // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidUnload
{
  [super viewDidUnload];
  // Release any retained subviews of the main view.
  // e.g. self.myOutlet = nil;
}

- (void)viewDidAppear:(BOOL)animated
{
  [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
  [super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
  [super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
  // Return YES for supported orientations
  return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Table view data source

/*
 // Override to support conditional editing of the table view.
 - (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
 {
 // Return NO if you do not want the specified item to be editable.
 return YES;
 }
 */

/*
 // Override to support editing the table view.
 - (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
 {
 if (editingStyle == UITableViewCellEditingStyleDelete) {
 // Delete the row from the data source
 [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
 }   
 else if (editingStyle == UITableViewCellEditingStyleInsert) {
 // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
 }   
 }
 */

/*
 // Override to support rearranging the table view.
 - (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
 {
 }
 */

/*
 // Override to support conditional rearranging of the table view.
 - (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
 {
 // Return NO if you do not want the item to be re-orderable.
 return YES;
 }
 */

#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
  // Navigation logic may go here. Create and push another view controller.
  /*
   <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
   // ...
   // Pass the selected object to the new view controller.
   [self.navigationController pushViewController:detailViewController animated:YES];
   [detailViewController release];
   */
}

#pragma mark - Existing methods (in the original template) that were amended

- (void)dealloc
{
  // Relinquish our interest in the cost centres array.
  [costCentres release];
  [super dealloc];
}

- (void)viewDidLoad
{
  [super viewDidLoad];
  
  // Set the title to display cost centre
  [self setTitle:NSLocalizedString(@"Cost centres", @"Cost centre names")];
  
  // Add an edit button on the left side
  self.navigationItem.leftBarButtonItem = self.editButtonItem;
  // Add an Add button on the right side
  UIBarButtonItem *addButton =
  [[UIBarButtonItem alloc] 
   initWithBarButtonSystemItem:UIBarButtonSystemItemAdd 
   target:self
   action:@selector(insertNewCostCentre)];
  self.navigationItem.rightBarButtonItem = addButton;
  [addButton release];
  
  // Get a list of projects from core data
  iTimesheetAppDelegate *ad = [iTimesheetAppDelegate sharedAppDelegate];
  NSArray *list = [ad allInstancesOf:@"CostCentre" orderedBy:@"name"];
  [self setCostCentres:[list mutableCopy]];
  
  // Uncomment the following line to preserve selection between presentations.
  // self.clearsSelectionOnViewWillAppear = NO;
  
  // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
  // self.navigationItem.rightBarButtonItem = self.editButtonItem;
}

- (void)viewWillAppear:(BOOL)animated {
  [super viewWillAppear:animated];
  // Are we returning from InsertCostCentreViewController?
  if (ccvc) {
    NSString *ccName = [ccvc costCentreName];
    // Do we have a name?
    if ([ccName length] > 0) {
      // Insert the new cost centre via core data's managed object context
      iTimesheetAppDelegate *ad = [iTimesheetAppDelegate sharedAppDelegate];
      NSManagedObjectContext *moc = [ad managedObjectContext];
      PPCostCentre *cc = [NSEntityDescription 
                          insertNewObjectForEntityForName:@"CostCentre"
                          inManagedObjectContext:moc];
      
      // Populate the cost centre object from user selections
      cc.name = ccName;
      cc.unit = [ccvc costCentreUnit];
      cc.hourlyRate = [NSNumber numberWithDouble:[[ccvc costCentreRate] 
                                                  doubleValue]];
      // Add it to our list of cost centres
      [costCentres addObject:cc];
      // Re-sort the array
      NSSortDescriptor *sd = [[NSSortDescriptor alloc] initWithKey:@"name"
                                                         ascending:YES];
      NSArray *sds = [NSArray arrayWithObject:sd];
      [sd release];
      [costCentres sortUsingDescriptors:sds];
      // Re-display the table view
      [[self tableView] reloadData];
    }
    // We've finished with the cost centre view controller so relinquish our 
    // interest in it & set it to nil so it will be correctly re-created as
    // needed.
    [ccvc release];
    ccvc = nil;
  }
  
  // Reload our tableview's data so the new cost centre will be shown
  [[self tableView] reloadData];
  
  // Clear the selection
  NSIndexPath *selectedPath = [[self tableView] indexPathForSelectedRow];
  if (selectedPath) {
    [[self tableView] deselectRowAtIndexPath:selectedPath animated:YES];
  }
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
  // Return the number of sections.
  // We are not grouping cost centre details so we only have one section.
  return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
  // Return the number of rows in the section.
  // We want one row for each cost centre in our array, so return the count
  return [[self costCentres] count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
  // Unique identifier for cells in this table
  static NSString *CellIdentifier = @"Cell";
  
  // Try to reuse an existing cell if possible
  UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
  
  // We couldn't get an existing cell so we need to create a new one
  if (cell == nil) {
    cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleValue1
                                   reuseIdentifier:CellIdentifier] autorelease];
  }
  
  // Configure the cell...
  
  // Now that we've got a cell, we want to put our cost centre details into it for
  // display.  We use the table row as the index into our cost centre array
  PPCostCentre *cc = [costCentres objectAtIndex:[indexPath row]];
  if (cc != nil) {
    // set the cell details from our cost centre
    cell.textLabel.text = [cc name];
    cell.detailTextLabel.text = [NSString stringWithFormat:@"%@%@/hr", 
                                 [cc unit], [cc hourlyRate]];
  }
  return cell;
}

#pragma mark - Added methods (did not exist in original template code)

-(void)insertNewCostCentre {
  // Create a view controller.
  ccvc = [[InsertCostCentreViewController alloc] init];
  // Push it onto our navigation controllers stack
  [[self navigationController] pushViewController:ccvc animated:YES];
}

-(void)removeCostCentre:(NSUInteger)index {
  // Get the cost centre associated with the index & remove its managed object
  // via core data's managed object context.
  PPCostCentre *cc = [costCentres objectAtIndex:index];
  iTimesheetAppDelegate *ad = [iTimesheetAppDelegate sharedAppDelegate];
  NSManagedObjectContext *moc = [ad managedObjectContext];
  [moc deleteObject:cc];
  
  // Delete the cost centre object as well
  [costCentres removeObjectAtIndex:index];
}

@end
