//
//  SettingsViewController.h
//  iTimesheet
//
//  Created by Mark Brindle on 25/03/2011.
//  Copyright 2011 ARKEMM Software Limited. All rights reserved.
//

#import <UIKit/UIKit.h>
// Provides networking interrogation methods
#import "UIDevice-Reachability.h"

// Added delegate support for table view & networking
@interface SettingsViewController : UIViewController 
  <UITableViewDataSource, UITableViewDelegate,
  ReachabilityWatcher, NSXMLParserDelegate> {
    
  NSMutableArray  *downloads;
    
  UILabel         *connectionText;
  UITableView     *downloadTable;

  BOOL            waitingForEntryTitle;

  NSMutableData   *xmlData; 
	NSURLConnection *connectionInProgress; 
	NSMutableString *titleString;

}

@property (nonatomic, retain) IBOutlet UILabel *connectionText;
@property (nonatomic, retain) IBOutlet UITableView *downloadTable;

// Manually added methods
- (void)reachabilityChanged;

- (BOOL)connectedToNetwork;

- (void)checkConnection;
- (void)loadSongs;

- (IBAction)doDownload:(id)sender;

@end
